let defined_fonts = {};
let default_font;
let default_margin_multiplier;
let default_text_color;

function storeLoadedFonts(fonts, names) {
    for(let i = 0; i<fonts.length; i++) {
        defined_fonts[fonts[i].name] = names[i];
    }
}

function loadedFont(font_name) {
    return defined_fonts[font_name];
}

function defaultFont() {
    return default_font;
}

function defaultMarginMultiplier() {
    return default_margin_multiplier;
}

function defaultTextColor() {
    return default_text_color;
}

function storeTheme(theme) {
    if (theme == null)
        return;

    if (Array.isArray(theme.font_family))
        storeDefaultFont(theme.font_family);

    if (theme.text_color)
        default_text_color = theme.text_color;

    if (typeof theme.line_spacing_multiplier === 'number')
        default_margin_multiplier = theme.line_spacing_multiplier;
}

function storeDefaultFont(fontFamily) {
    for (let i = 0; i < fontFamily.length; i++) {
        let loadedFont = defined_fonts[fontFamily[i]];
        if (loadedFont != null) {
            default_font = loadedFont;
            break;
        }
    }
}

module.exports = {
    storeLoadedFonts : storeLoadedFonts,
    loadedFont : loadedFont,
    defaultFont : defaultFont,
    defaultTextColor : defaultTextColor,
    defaultMarginMultiplier : defaultMarginMultiplier,
    storeTheme : storeTheme
}



