function trim (str) {
    return str.replace(/^\s+|\s+$/gm,'');
}

function fixLength(hex){
    if (hex.length === 1)
        hex = "0" + hex;
    return hex;
}

function convertToHex(rgba) {
    if(rgba.substring(0, 3) !== 'rgb')
        return {hex: rgba};

    let parts = rgba.substring(rgba.indexOf("(")).slice(0, -1).split(",");
    let r = parseInt(trim(parts[0].substring(1)), 10),
        g = parseInt(trim(parts[1]), 10),
        b = parseInt(trim(parts[2]), 10);
    let returnObject = {hex: ('#' + fixLength(r.toString(16))  + fixLength(g.toString(16)) + fixLength(b.toString(16)))}
    if (parts.length === 4)
        returnObject.opacity = parseFloat(trim(parts[3]));

    return returnObject;
}

module.exports = convertToHex;
