import React, { Component } from 'react';
import { View, FlatList, Text, Image } from 'react-native';
import { IncitoView, IncitoTextView, IncitoLinearLayout, IncitoAbsoluteLayout, IncitoImageView, IncitoFragView, IncitoFlexLayout, IncitoVideoView } from '../views';

viewConverter = function(attr, childViews) {
    switch(attr.view_name){
        case 'AbsoluteLayout':
            return new IncitoAbsoluteLayout(attr, childViews);
        case 'FlexLayout':
            return new IncitoFlexLayout(attr, childViews);
        case 'ImageView':
            return new IncitoImageView(attr, childViews);
        case 'LinearLayout':
            return new IncitoLinearLayout(attr, childViews);
        case 'TextView':
            return new IncitoTextView(attr, childViews);
        case 'VideoView':
            return new IncitoVideoView(attr, childViews);
        default:
            return new IncitoView(attr, childViews);
    }
}

module.exports = viewConverter
