import React, { Component } from 'react';
import IncitoView from './view'

class IncitoFlexLayout extends IncitoView {

    customStyle(style) {

        if (['stretch', 'center', 'flex-start', 'flex-end', 'baseline'].indexOf(this.attributes().layout_flex_align_items) !== -1)
            style.alignSelf = this.attributes().layout_flex_align_items;

        if (['stretch', 'center', 'flex-start', 'flex-end', 'space-between', 'space-around', 'initial'].indexOf(this.attributes().layout_flex_align_content) !== -1)
            style.alignContent = this.attributes().layout_flex_align_content;

        if (['flex-start', 'flex-end', 'center', 'space-between', 'space-around'].indexOf(this.attributes().layout_flex_justify_content) !== -1)
            style.justifyContent = this.attributes().layout_flex_justify_content;

        if (['row', 'column'].indexOf(this.attributes().layout_flex_direction) !== -1)
            style.flexDirection = this.attributes().layout_flex_direction;

        if (typeof this.attributes().layout_flex_shrink === 'number')
            style.flexShrink = this.attributes().layout_flex_shrink;

        if (typeof this.attributes().layout_flex_grow === 'number')
            style.flexGrow = this.attributes().layout_flex_grow;

        if (typeof this.attributes().layout_flex_basis === 'number')
            style.flexBasis = this.attributes().layout_flex_basis;
        
        return style;
    }
}

module.exports = IncitoFlexLayout
